import os,sys
from numpy import *
import numpy
from numpy.linalg import eigh

def L2(qn1,qn2) :
  em = qn1[2]
  ellsq = 0.0
  if qn2[2] == em :
    nz1 = qn1[0]; nr1=qn1[1]
    if nz1 == qn2[0] and nr1  == qn2[1] :    
      ellsq += em**2
      mabs=abs(em)
      ellsq += (2*nz1+1)*(2*nr1+mabs) + 2*nz1
    elif nz1 == (qn2[0]+2) and nr1 == (qn2[1] -1) :
      ellsq +=  2*(nz1*(nz1-1)*(nr1+1)*(nr1+abs(em)+1))**0.5
    elif nz1 == (qn2[0]-2) and nr1 == (qn2[1] +1) :
      ellsq +=  2*((nz1+1)*(nz1+2)*(nr1)*(nr1+abs(em)))**0.5
  return ellsq

def LS(qn1,qn2):
  s1 = qn1[3]; m1 = qn1[2]
  ells = 0.0
  if s1 == qn2[3] :
    if  qn1[0] == qn2[0] and qn1[1] == qn2[1]: # lz dot sz only
      ells = s1*m1
    else:
      ells = 0.0
  elif (s1-qn2[3]) == 2*(qn2[2] - m1) :
    if m1 >= 0 :
      np1 = qn1[1]+ m1; nm1 = qn1[1]
    else:
      np1 = qn1[1]; nm1 = qn1[1] - m1
    m2 = qn2[2]
    if m2 >= 0 :
      np2 = qn2[1]+ m2; nm2 = qn2[1]
    else:
      np2 = qn2[1]; nm2 = -m2 + qn2[1]
    if qn2[0] == (qn1[0]+1) and nm2 < nm1: ells = (2*nm1*qn2[0])**0.5
    if qn2[0] == (qn1[0]+1) and np2 < np1: ells = (2*np1*qn2[0])**0.5
    if qn2[0] == (qn1[0]-1) and nm2 > nm1: ells = (2*nm2*qn1[0])**0.5
    if qn2[0] == (qn1[0]-1) and np2 > np1: ells = (2*np2*qn1[0])**0.5   

  return ells


def pnice(mat,title='pnice') :     #print out matrix, nicely formated
  dim=shape(mat)[0]
  print title 
  for i in range(dim) :
    ss=''
    for j in range(dim):
       t1=mat[i,j] 
       if abs(t1) < 0.0001 :
         ss +='   0   ' 
       else :
         ss +=' %6.3f' % mat[i,j]
    print ss
  print
